(PackageInfo named: 'ContextS2') preamble: '"below, add code to be run before the loading of this package"

"Thread local storage for thread-local layer activation.
Is there a way to store inst vars of a class in Monticello extensions??"

(Process instVarNames includes: #activeLayers) 
	ifFalse: [Process addInstVarName: ''activeLayers'' ]

'!
SystemOrganization addCategory: #ContextS2!
SystemOrganization addCategory: #'ContextS2-Tests-Sandbox'!
SystemOrganization addCategory: #'ContextS2-Tests'!
(PackageInfo named: 'ContextS2') postscript: '"ContextS2 overwrites Behavior>>#basicAddSelector:withMethod: (extensions).
Since the method is used by Monticello it has to be added after the load (ContextS2PostLoad)."

| repository project repo |

repository := ''http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/''.
project := ''ContextSTrunk''.

repo := MCRepositoryGroup default repositories detect: 
	[ :each | (each respondsTo: #locationWithTrailingSlash) and: [each locationWithTrailingSlash = (repository, project, ''/'')]].

((Smalltalk at: #InstallerMonticello ifAbsent: [self error: ''You need InstallerMonticello to load (Version 4.0)'']) new 
	http: repository user: repo user password: repo password)
	project: project;
	install: ''ContextS2PostLoad''.'!

!CompiledMethod methodsFor: '*ContextS2' stamp: 'mpe 8/4/2010 01:10'!
asPartialMethod
	| layerPragma args |
	layerPragma := self pragmas 
		detect: [:each | #(before: after: around:) includes: each keyword] 
		ifNone: [^ CSPartialMethod
				layer: nil 
				method: self
				when: #base].
	args := layerPragma arguments first isSymbol 
			ifTrue: [Array with: layerPragma arguments first]
			ifFalse: [layerPragma arguments first].
	^ CSPartialMethod
				layer: args 
				method: self
				when: layerPragma keyword! !

!CompiledMethodWithNode class methodsFor: '*ContextS2' stamp: 'mpe 2/16/2011 11:41'!
generateMethodFromNode: aMethodNode trailer: bytes
	| method |
	method := aMethodNode generate: bytes.
	(method pragmas anySatisfy: [:each | #(before: after: around: types:) includes: each keyword ])
		ifTrue: [method := method asPartialMethod].
	^ self method: method node: aMethodNode.! !

!Parser class methodsFor: '*ContextS2' stamp: 'mpe 8/3/2010 22:21'!
primitivePragmaSelectors
	"Answer the selectors of pragmas that specify VM primitives.
	 Needed for compile and decomple."
	^#(primitive:
		primitive:error:
		primitive:error:module:
		primitive:module:
		primitive:module:error:
		before:
		around:
		after:)! !

!Parser methodsFor: '*ContextS2' stamp: 'mpe 8/4/2010 00:28'!
after: aCollectionOfLayers
	^ 0! !

!Parser methodsFor: '*ContextS2' stamp: 'mpe 8/4/2010 00:28'!
around: aCollectionOfLayers
	^ 0! !

!Parser methodsFor: '*ContextS2' stamp: 'mpe 8/4/2010 00:29'!
before: aCollectionOfLayers
	^ 0! !

!Parser methodsFor: '*ContextS2' stamp: 'mpe 2/16/2011 11:36'!
types:  aCollectionOfTypes
	^ 0! !

Browser subclass: #CSContextBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSContextBrowser methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:18'!
buildMethodSwitchesWith: builder
	"Build the instance/comment/class switch"
	| panelSpec buttonSpec |
	panelSpec := builder pluggablePanelSpec new.
	panelSpec children: OrderedCollection new.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'base'; 
			enabled: #isLayeredMethodAndHasABase; 
			action: #showBaseMethod;
			frame: (0@0 corner: 0.5@1).
	panelSpec children addLast: buttonSpec.

	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec 
			model: self;
			label: 'partial'; 
			enabled: #isLayeredMethod; 
			action: #showPartialMethod;
			frame: (0.5@0 corner: 1@1).
	panelSpec children addLast: buttonSpec.

	^panelSpec! !

!CSContextBrowser methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:08'!
choosePartialMethodFrom: layeredMethod
	^ UIManager default 
		chooseFrom: (layeredMethod methods collect: [:each | each asMenuString]) 
		values: layeredMethod methods 
		lines: #() 
		title: 'Choose partial method'.! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'mpe 8/6/2010 20:42'!
defaultBrowserTitle
	^ 'Context Browser'
! !

!CSContextBrowser methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:04'!
isLayeredMethod

	self methodReference ifNil: [^ false].
	^ self methodReference compiledMethod class == CSLayeredMethod! !

!CSContextBrowser methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:50'!
isLayeredMethodAndHasABase
	self methodReference ifNil: [^ false].
	self isLayeredMethod
		ifTrue: [^ self methodReference compiledMethod includesBaseMethod]
		ifFalse: [^ true]! !

!CSContextBrowser methodsFor: 'initialize-release' stamp: 'mpe 8/6/2010 20:50'!
openEditString: aString
        "Create a pluggable version of all the views for a Browser, including views and controllers."
	"Example: 
		Browser fullOnClass: Browser.
	"
	| builder max |
	builder := ToolBuilder default.
	max := self wantsOptionalButtons ifTrue:[0.42] ifFalse:[0.5].
	^self buildWindowWith: builder specs: {
		(0@0 corner: 0.25@max) -> [self buildSystemCategoryListWith: builder].
		(0.25@0 corner: 0.5@(max-0.08)) -> [self buildClassListWith: builder].
		(0.25@(max-0.08) corner: 0.5@max) -> [self buildSwitchesWith: builder].
		(0.5@0 corner: 0.75@max) -> [self buildMessageCategoryListWith: builder].
		(0.75@0 corner: 1@(max-0.08)) -> [self buildMessageListWith: builder].
		(0.75@(max-0.08) corner: 1@max) -> [self buildMethodSwitchesWith: builder].
		"(0@max corner: 1@0.5) -> [self buildOptionalButtonsWith: builder]."
		(0@max corner: 1@1) -> [self buildCodePaneWith: builder].
	}! !

!CSContextBrowser methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:30'!
refreshCodePane
	contents := nil.
	self contentsChanged
	! !

!CSContextBrowser methodsFor: 'as yet unclassified' stamp: 'mpe 8/10/2010 20:57'!
removePartialMethod
	| layeredMethod decision |
	self methodReference ifNil: [^ self].
	layeredMethod := self methodReference compiledMethod.
	layeredMethod class == CSLayeredMethod ifFalse: [^ self].
	decision := self choosePartialMethodFrom: layeredMethod.
	decision ifNotNil: [
		layeredMethod methods size = 1
			ifTrue: [^ self removeMessage].
		layeredMethod removePartialMethod: decision.
		self refreshCodePane].
	! !

!CSContextBrowser methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:30'!
showBaseMethod
	| layeredMethod |
	self methodReference ifNil: [^ self].
	layeredMethod := self methodReference compiledMethod.
	layeredMethod class == CSLayeredMethod
		ifTrue: [layeredMethod selectedPartialMethod: layeredMethod baseMethod.
				self refreshCodePane].! !

!CSContextBrowser methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:30'!
showPartialMethod
	| layeredMethod decision |
	self methodReference ifNil: [^ self].
	layeredMethod := self methodReference compiledMethod.
	decision := self choosePartialMethodFrom: layeredMethod.
	decision ifNotNil: [
		layeredMethod selectedPartialMethod: decision.
		self refreshCodePane].
	! !

!Process methodsFor: '*ContextS2' stamp: 'mpe 8/3/2010 23:00'!
activeLayers
	"Answer the value of activeLayers"

	^ activeLayers ifNil: [activeLayers := #()]! !

!Process methodsFor: '*ContextS2' stamp: 'mp 6/11/2010 20:39'!
activeLayers: anObject
	"Set the value of activeLayers"

	activeLayers := anObject! !

!Behavior methodsFor: '*ContextS2' stamp: 'mpe 8/6/2010 17:15'!
contextSConversionOld: oldMethodOrNil new: aNewMethod
	((aNewMethod class == CompiledMethod) and: [oldMethodOrNil class == CSLayeredMethod])
		ifTrue: [	oldMethodOrNil addBaseMethod: aNewMethod.
				^ oldMethodOrNil].
	aNewMethod class == CSPartialMethod
		ifTrue: [	oldMethodOrNil ifNil: [^ CSLayeredMethod on: {aNewMethod}].
				oldMethodOrNil class == CompiledMethod
					ifTrue: [^ CSLayeredMethod on: {aNewMethod. oldMethodOrNil asPartialMethod}].
				oldMethodOrNil class == CSLayeredMethod
					ifTrue: [	oldMethodOrNil addPartialMethod: aNewMethod.
							^ oldMethodOrNil]].
	"previous nil and compiled method entries are standard behavior"
	^ aNewMethod! !

TestCase subclass: #CSBehavioralVariationsTest
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSBehavioralVariationsTest methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:30'!
a
	"Answer the value of a"

	^ a! !

!CSBehavioralVariationsTest methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:30'!
a: anObject
	"Set the value of a"

	a := anObject! !

!CSBehavioralVariationsTest methodsFor: 'running' stamp: 'mpe 11/7/2010 18:30'!
setUp

	self a: CSClassA new.! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 18:33'!
test01ExecuteBaseMethod

	self a myMethod.
	self assert: self a executedMethods size = 1.
	self assert: self a executedMethodsArray = #(base).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 19:06'!
test02ExecuteBeforeBaseMethod

	#beforeLayer withLayerDo: [self a myMethod].
	self assert: self a executedMethods size = 2.
	self assert: self a executedMethodsArray = #(beforeLayer base).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 19:06'!
test03ExecuteBaseAfterMethod

	#afterLayer withLayerDo: [self a myMethod].
	self assert: self a executedMethods size = 2.
	self assert: self a executedMethodsArray = #(base afterLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 19:06'!
test04aExecuteBeforeBaseAfterMethod

	#(beforeLayer afterLayer) withLayersDo: [self a myMethod].
	self assert: self a executedMethods size = 3.
	self assert: self a executedMethodsArray = #(beforeLayer base afterLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 19:06'!
test04bExecuteBeforeBaseAfterMethod

	#(afterLayer beforeLayer) withLayersDo: [self a myMethod].
	self assert: self a executedMethods size = 3.
	self assert: self a executedMethodsArray = #(beforeLayer base afterLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 19:06'!
test05ExecuteAroundMethod

	#aroundLayer withLayerDo: [self a myMethod].
	self assert: self a executedMethods size = 1.
	self assert: self a executedMethodsArray = #(aroundLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 20:11'!
test06ExecuteAroundProceedBaseMethod

	#aroundProceedLayer withLayerDo: [self a myMethod].
	self assert: self a executedMethods size = 2.
	self assert: self a executedMethodsArray = #(aroundProceedLayer base).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 20:13'!
test07aExecuteAroundProceedAroundMethod

	#(aroundProceedLayer aroundLayer) withLayersDo: [self a myMethod].
	self assert: self a executedMethods size = 1.
	self assert: self a executedMethodsArray = #(aroundLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 20:13'!
test07bExecuteAroundProceedAroundMethod

	#(aroundLayer aroundProceedLayer) withLayersDo: [self a myMethod].
	self assert: self a executedMethods size = 2.
	self assert: self a executedMethodsArray = #(aroundProceedLayer aroundLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 20:15'!
test08ExecuteBeforeAroundAfterMethod
	#(beforeLayer aroundLayer afterLayer) withLayersDo: [self a myMethod].
	self assert: self a executedMethods size = 3.
	self assert: self a executedMethodsArray = #(beforeLayer aroundLayer afterLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 20:15'!
test09ExecuteBeforeAroundProceedBaseAfterMethod
	#(beforeLayer aroundProceedLayer afterLayer) withLayersDo: [self a myMethod].
	self assert: self a executedMethods size = 4.
	self assert: self a executedMethodsArray = #(beforeLayer aroundProceedLayer base afterLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 11/7/2010 20:16'!
test10ExecuteBeforeAroundProceedAroundAfterMethod
	#(beforeLayer aroundLayer aroundProceedLayer afterLayer) withLayersDo: [self a myMethod].
	self assert: self a executedMethods size = 4.
	self assert: self a executedMethodsArray = #(beforeLayer aroundProceedLayer aroundLayer afterLayer).! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 2/16/2011 12:14'!
test11aReturnValueFromAround
	#(aroundLayer) withLayersDo: [self assert: self a myReturnMethod = #around].! !

!CSBehavioralVariationsTest methodsFor: 'testing' stamp: 'mpe 2/16/2011 12:14'!
test11bReturnValueFromBase
	self assert: self a myReturnMethod = #base.! !

TestCase subclass: #CSContextSTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

CSContextSTest subclass: #CSAddingMethodsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:03'!
test01AddCompiledMethodExistingNil
	self deny: (CSClassA methodDict keys includes: self generatedSelector).
	self addMethodFrom: self baseCode toClass: CSClassA.
	self assert: (CSClassA methodDict keys includes: self generatedSelector).
	self assert: (CSClassA>>self generatedSelector) class == CompiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:00'!
test02AddCompiledMethodExistingCompiledMethod
	| compiledMethod |
	self addMethodFrom: self baseCode toClass: CSClassA.
	compiledMethod := CSClassA>>self generatedSelector.
	self addMethodFrom: self baseCode toClass: CSClassA.
	self deny: CSClassA>>self generatedSelector == compiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:00'!
test03aAddCompiledMethodExistingLayeredMethodWithoutBase
	| layeredMethod |
	self addMethodFrom: self beforeCode toClass: CSClassA.
	layeredMethod := CSClassA>>self generatedSelector.
	self deny: layeredMethod includesBaseMethod.
		
	self addMethodFrom: self baseCode toClass: CSClassA.
	self assert: layeredMethod includesBaseMethod.
	self assert: layeredMethod methods last class == CSPartialMethod.
	self assert: layeredMethod methods last == layeredMethod baseMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:00'!
test03bAddCompiledMethodExistingLayeredMethodWithBase
	| layeredMethod oldBaseMethod |
	self addMethodFrom: self baseCode toClass: CSClassA.
	self addMethodFrom: self beforeCode toClass: CSClassA.
	layeredMethod := CSClassA>>self generatedSelector.
	self assert: layeredMethod methods size = 2.
	oldBaseMethod := layeredMethod baseMethod.

	self addMethodFrom: self baseCode toClass: CSClassA.
	self assert: layeredMethod methods size = 2.	
	self deny: layeredMethod baseMethod == oldBaseMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:00'!
test04AddPartialMethodExistingNil
	| layeredMethod |
	self deny: (CSClassA methodDict keys includes: self generatedSelector).
	self addMethodFrom: self beforeCode toClass: CSClassA.
	self assert: (CSClassA methodDict keys includes: self generatedSelector).
	layeredMethod := CSClassA>>self generatedSelector.
	self assert: layeredMethod class == CSLayeredMethod.
	self deny: layeredMethod includesBaseMethod.
	self assert: layeredMethod methods size = 1.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:00'!
test05AddPartialMethodExistingCompiledMethod
	| compiledMethod layeredMethod |
	self addMethodFrom: self baseCode toClass: CSClassA.
	compiledMethod := CSClassA>>self generatedSelector.
	self assert: compiledMethod class == CompiledMethod.
	
	self addMethodFrom: self beforeCode toClass: CSClassA.
	layeredMethod := CSClassA>>self generatedSelector.
	self assert: layeredMethod class == CSLayeredMethod.
	self assert: layeredMethod methods size = 2.
	self assert: layeredMethod baseMethod method == compiledMethod.
	self assert: layeredMethod methods second method == compiledMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:01'!
test06aAddPartialMethodExistingLayeredMethodLayerCombinationNotExistingWithBase
	| layeredMethod |
	self addMethodFrom: self baseCode toClass: CSClassA.
	self addMethodFrom: self beforeCode toClass: CSClassA.
	layeredMethod := CSClassA>>self generatedSelector.
	self assert: layeredMethod methods size = 2.
	
	self addMethodFrom: self beforeCodeMultipleLayer toClass: CSClassA.
	self assert: layeredMethod methods size = 3.
	self assert: layeredMethod methods first layer = #(l1).
	self assert: layeredMethod methods second layer = #(l1 l2 l3).
	self assert: layeredMethod methods third == layeredMethod baseMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:01'!
test06bAddPartialMethodExistingLayeredMethodLayerCombinationNotExistingWithoutBase
	| layeredMethod |
	self addMethodFrom: self beforeCode toClass: CSClassA.
	layeredMethod := CSClassA>>self generatedSelector.
	self assert: layeredMethod methods size = 1.
	
	self addMethodFrom: self beforeCodeMultipleLayer toClass: CSClassA.
	self assert: layeredMethod methods size = 2.
	self assert: layeredMethod methods first layer = #(l1).
	self assert: layeredMethod methods second layer = #(l1 l2 l3).
	self deny: layeredMethod includesBaseMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:01'!
test06cAddPartialMethodExistingLayeredMethodLayerCombinationExistingSingle
	| layeredMethod oldPartialMethod |
	self addMethodFrom: self baseCode toClass: CSClassA.
	self addMethodFrom: self beforeCode toClass: CSClassA.
	layeredMethod := CSClassA>>self generatedSelector.
	self assert: layeredMethod methods size = 2.
	oldPartialMethod := layeredMethod methods first.
	
	self addMethodFrom: self beforeCode toClass: CSClassA.
	self assert: layeredMethod methods size = 2.
	self assert: layeredMethod methods first layer = #(l1).
	self assert: layeredMethod methods second == layeredMethod baseMethod.
	self deny: layeredMethod methods first == oldPartialMethod.! !

!CSAddingMethodsTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:01'!
test06dAddPartialMethodExistingLayeredMethodLayerCombinationExistingMultiple
	| layeredMethod oldPartialMethod |
	self addMethodFrom: self baseCode toClass: CSClassA.
	self addMethodFrom: self beforeCodeMultipleLayer toClass: CSClassA.
	layeredMethod := CSClassA>>self generatedSelector.
	self assert: layeredMethod methods size = 2.
	oldPartialMethod := layeredMethod methods first.
	
	self addMethodFrom: self beforeCodeMultipleLayer toClass: CSClassA.
	self assert: layeredMethod methods size = 2.
	self assert: layeredMethod methods first layer = #(l1 l2 l3).
	self assert: layeredMethod methods second == layeredMethod baseMethod.
	self deny: layeredMethod methods first == oldPartialMethod.! !

CSContextSTest subclass: #CSCompilerExtensionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:04'!
compile: aSourceCodeString
	
	^ (CSClassA
		compile: aSourceCodeString
		classified: 'generated partial methods'
		notifying: nil
		trailer: CompiledMethodTrailer empty
		ifFail: nil	) method! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 21:22'!
test01CompileBaseMethod
	| method |
	method := self compile: self baseCode.
	self assert: method class = CompiledMethod.
	self deny: (CSClassA methodDict includes: self generatedSelector).
	CSClassA methodDict at: self generatedSelector put: method.
	self assert: (CSClassA methodDict keys includes: self generatedSelector).
	self assert: CSClassA>>self generatedSelector == method.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/4/2010 00:12'!
test02CompileBaseMethodAsPartialMethod
	| method |
	method := (self compile: self baseCode) asPartialMethod.
	self assert: method class = CSPartialMethod.
	self assert: method layer isNil.
	self assert: method when == #base.
	self assert: method method class == CompiledMethod.
	self assert: method method = (self compile: self baseCode).! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/4/2010 01:00'!
test03aCompileBeforeMethod
	| method |
	method := self compile: self beforeCode.
	self assert: method class = CSPartialMethod.
	self assert: method layer = #(l1).
	self assert: method when == #before:.
	self assert: method method class == CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/4/2010 01:04'!
test03bCompileBeforeMethodMultipleLayer
	| method |
	method := self compile: self beforeCodeMultipleLayer.
	self assert: method class = CSPartialMethod.
	self assert: method layer = #(l1 l2 l3).
	self assert: method when == #before:.
	self assert: method method class == CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/4/2010 01:02'!
test04aCompileAroundMethod
	| method |
	method := self compile: self aroundCode.
	self assert: method class = CSPartialMethod.
	self assert: method layer = #(l1).
	self assert: method when == #around:.
	self assert: method method class == CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/4/2010 01:06'!
test04bCompileAroundMethodMultipleLayer
	| method |
	method := self compile: self aroundCodeMultipleLayer.
	self assert: method class = CSPartialMethod.
	self assert: method layer = #(l1 l2 l3).
	self assert: method when == #around:.
	self assert: method method class == CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/4/2010 01:02'!
test05aCompileAfterMethod
	| method |
	method := self compile: self afterCode.
	self assert: method class = CSPartialMethod.
	self assert: method layer = #(l1).
	self assert: method when == #after:.
	self assert: method method class == CompiledMethod.! !

!CSCompilerExtensionTest methodsFor: 'testing' stamp: 'mpe 8/4/2010 01:06'!
test05bCompileAfterMethodMultipleLayer
	| method |
	method := self compile: self afterCodeMultipleLayer.
	self assert: method class = CSPartialMethod.
	self assert: method layer = #(l1 l2 l3).
	self assert: method when == #after:.
	self assert: method method class == CompiledMethod.! !

!CSContextSTest methodsFor: 'adding' stamp: 'mpe 8/10/2010 21:42'!
addMethodFrom: aSourceCodeString toClass: aClass
	
	^ aClass
		compile: aSourceCodeString
		classified: 'generated partial methods'
		withStamp: Utilities changeStamp
		notifying: nil! !

!CSContextSTest methodsFor: 'method code empty' stamp: 'mpe 8/10/2010 21:12'!
afterCode
	^ 'generatedPartialMethod
		<after: #l1>
		^ self'! !

!CSContextSTest methodsFor: 'method code empty' stamp: 'mpe 8/10/2010 21:13'!
afterCodeMultipleLayer
	^ 'generatedPartialMethod
		<after: #(l1 l2 l3)>
		^ self'! !

!CSContextSTest methodsFor: 'method code empty' stamp: 'mpe 8/10/2010 21:13'!
aroundCode
	^ 'generatedPartialMethod
		<around: #l1>
		^ self'! !

!CSContextSTest methodsFor: 'method code empty' stamp: 'mpe 8/10/2010 21:13'!
aroundCodeMultipleLayer
	^ 'generatedPartialMethod
		<around: #(l1 l2 l3)>
		^ self'! !

!CSContextSTest methodsFor: 'method code empty' stamp: 'mpe 8/10/2010 21:13'!
baseCode
	^ 'generatedPartialMethod
		^ self'! !

!CSContextSTest methodsFor: 'method code empty' stamp: 'mpe 8/10/2010 21:13'!
beforeCode
	^ 'generatedPartialMethod
		<before: #l1>
		^ self'! !

!CSContextSTest methodsFor: 'method code empty' stamp: 'mpe 8/10/2010 21:13'!
beforeCodeMultipleLayer
	^ 'generatedPartialMethod
		<before: #(l1 l2 l3)>
		^ self'! !

!CSContextSTest methodsFor: 'accessing' stamp: 'mpe 8/10/2010 21:04'!
generatedSelector

	^ #generatedPartialMethod! !

!CSContextSTest methodsFor: 'running' stamp: 'mpe 8/10/2010 21:58'!
tearDown
	CSClassA removeSelector: self generatedSelector.! !

CSContextSTest subclass: #CSPartialMethodTest
	instanceVariableNames: 'partialMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSPartialMethodTest methodsFor: 'accessing' stamp: 'mpe 8/10/2010 21:34'!
partialCountMethod
	^ 'generatedPartialMethod
		<before: #l1>
		^ count + 1'! !

!CSPartialMethodTest methodsFor: 'accessing' stamp: 'mpe 8/10/2010 22:19'!
partialMethodFrom: aClass
	^ (aClass >> self generatedSelector) methods first! !

!CSPartialMethodTest methodsFor: 'accessing' stamp: 'mpe 8/10/2010 22:14'!
partialSubCountMethod
	^ 'generatedPartialMethod
		<before: #l1>
		^ super generatedPartialMethod + count'
		! !

!CSPartialMethodTest methodsFor: 'accessing' stamp: 'mpe 8/10/2010 22:45'!
partialSubSuperCountMethod
	^ 'generatedPartialMethod
		<before: #l1>
		^ super count'
		! !

!CSPartialMethodTest methodsFor: 'running' stamp: 'mpe 8/10/2010 22:04'!
setUp
	self addMethodFrom: self partialCountMethod toClass: CSClassB! !

!CSPartialMethodTest methodsFor: 'running' stamp: 'mpe 8/10/2010 22:15'!
tearDown
	super tearDown.
	CSClassB removeSelector: self generatedSelector.
	CSSubclassB removeSelector: self generatedSelector.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:22'!
test01CompilePartialMethodAndToClass
	| partialMethod |
	partialMethod := self partialMethodFrom: CSClassB.
	self assert: partialMethod layer = #(l1).
	self assert: partialMethod method class == CompiledMethod.
	self assert: partialMethod method selector == #generatedPartialMethod.
	self assert: partialMethod method methodClass == CSClassB.
	self assert: partialMethod when = #before:.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:32'!
test02aCallPartialMethod

	self assert: ((self partialMethodFrom: CSClassB) valueWithReceiver: CSClassB new arguments: #()) = 2.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:32'!
test02bCallPartialMethodFromInstance
	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self assert: CSClassB new generatedPartialMethod = 2.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:42'!
test03CallPartialMethodWithSuperCall
	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self addMethodFrom: self partialSubCountMethod toClass: CSSubclassB.
	CSSubclassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSSubclassB).
	self assert: CSSubclassB new generatedPartialMethod = 3.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:50'!
test04CallPartialMethodWithSuperCallToStandardMethod

	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self addMethodFrom: self partialSubSuperCountMethod toClass: CSSubclassB.
	CSSubclassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSSubclassB).
	self assert: CSSubclassB new generatedPartialMethod = 1.! !

!CSPartialMethodTest methodsFor: 'testing' stamp: 'mpe 8/10/2010 22:51'!
test05CallPartialMethodFromSubclass

	CSClassB methodDict at: self generatedSelector put: (self partialMethodFrom: CSClassB).
	self assert: CSSubclassB new generatedPartialMethod = 2.! !

TestCase subclass: #CSLayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSLayerTest methodsFor: 'accessing' stamp: 'mp 6/11/2010 20:55'!
localActivatedLayers

	^ self process activeLayers! !

!CSLayerTest methodsFor: 'accessing' stamp: 'mp 6/11/2010 20:54'!
process
	^ Processor activeProcess! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'mp 6/13/2010 17:23'!
test01LayerCollectionInitialization

	self assert: self localActivatedLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'mpe 8/3/2010 23:07'!
test02aSingleLayerActivation
	#l1 withLayerDo: [
		self assert: self localActivatedLayers notEmpty.
		self assert: self localActivatedLayers first = #l1.
		].
	self assert: self localActivatedLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'mpe 8/3/2010 23:06'!
test02bSingleLayerActivation
	#(l1) withLayersDo: [
		self assert: self localActivatedLayers notEmpty.
		self assert: self localActivatedLayers first = #l1.
		].
	self assert: self localActivatedLayers isEmpty.
	! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'mpe 8/3/2010 23:10'!
test03NestedLayerActivation
	#l1 withLayerDo: [
		self assert: self localActivatedLayers notEmpty.
		self assert: self localActivatedLayers first = #l1.
		#l1 withLayerDo: [
			self assert: self localActivatedLayers size = 1.
			self assert: self localActivatedLayers first = #l1.
			#l1 withLayerDo: [
				self assert: self localActivatedLayers size = 1.
				self assert: self localActivatedLayers first = #l1.
				]
			].
		self assert: self localActivatedLayers size = 1.
		self assert: self localActivatedLayers first = 'l1'.
		].
	self assert: self localActivatedLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'mpe 8/3/2010 23:12'!
test04LayerDeactivation
	#l1 withLayerDo: [
		self assert: self localActivatedLayers size = 1.
		self assert: self localActivatedLayers first = #l1.
		#l1 withoutLayerDo: [
			self assert: self localActivatedLayers isEmpty.
			].
		self assert: self localActivatedLayers size = 1.
		self assert: self localActivatedLayers first = #l1.
		].
	self assert: self localActivatedLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'mpe 8/3/2010 23:19'!
test05MultipleLayerDeactivation
	#(l1 l2 l3) withLayersDo: [
		self assert: self localActivatedLayers size = 3.
		self assert: self localActivatedLayers last = #l3.
		#l2 withoutLayerDo: [
			self assert: self localActivatedLayers size = 2.
			self assert: self localActivatedLayers last = #l3.
			self assert: self localActivatedLayers first = #l1].
		self assert: self localActivatedLayers size = 3.
		self assert: self localActivatedLayers second = #l2.
		#(l1 l2) withoutLayersDo: [
			#l3 withoutLayerDo: [self assert: self localActivatedLayers isEmpty].
			self assert: self localActivatedLayers first = #l3].
		self assert: self localActivatedLayers size = 3.
		].
	self assert: self localActivatedLayers isEmpty.! !

!CSLayerTest methodsFor: 'layer tests' stamp: 'mpe 11/7/2010 18:06'!
test06LayerDeactivationInNonLocalReturns
	self assert: self localActivatedLayers isEmpty.
	self deny: CSClassA new nonLocalReturn.
	self assert: self localActivatedLayers isEmpty.! !

TestCase subclass: #CSMethodOverloadingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests'!

!CSMethodOverloadingTest methodsFor: 'testing' stamp: 'mpe 2/16/2011 11:26'!
testDefaultMethod
	| obj |
	obj := CSMethodOverloading new.
	self assert: (obj + 'string') = #base.! !

!CSMethodOverloadingTest methodsFor: 'testing' stamp: 'mpe 2/16/2011 11:34'!
testOverloadFloatType
	| obj |
	obj := CSMethodOverloading new.
	self assert: (obj + 1.2) = #Float.! !

!CSMethodOverloadingTest methodsFor: 'testing' stamp: 'mpe 2/16/2011 11:52'!
testOverloadIntegerType
	| obj |
	obj := CSMethodOverloading new.
	self assert: (obj + 1) = #Integer.! !

!CSMethodOverloadingTest methodsFor: 'testing' stamp: 'mpe 2/16/2011 11:21'!
testOverloadMultipleParameterTypes

	self assert: false.! !

!CSMethodOverloadingTest methodsFor: 'testing' stamp: 'mpe 2/16/2011 14:00'!
testTypesPragma
	| overloadedMethods |
	self assert: ((CSMethodOverloading>>#+) isKindOf: CSLayeredMethod).
	overloadedMethods := (CSMethodOverloading>>#+) methods select: [:each | each when == #types:].
	self assert: overloadedMethods size = 2.
	self assert: (overloadedMethods detect: [:each | each layer first == #Float]) notNil.
	self assert: (overloadedMethods detect: [:each | each layer first == #Integer]) notNil.

! !

Object subclass: #CSClassA
	instanceVariableNames: 'executedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSClassA methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:30'!
executed: aSymbol

	self executedMethods add: aSymbol.! !

!CSClassA methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:29'!
executedMethods
	"Answer the value of executedMethods"

	^ executedMethods! !

!CSClassA methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:29'!
executedMethods: anObject
	"Set the value of executedMethods"

	executedMethods := anObject! !

!CSClassA methodsFor: 'accessing' stamp: 'mpe 11/7/2010 18:32'!
executedMethodsArray

	^ self executedMethods asArray! !

!CSClassA methodsFor: 'initialize-release' stamp: 'mpe 11/7/2010 18:29'!
initialize
	
	self executedMethods: OrderedCollection new.! !

!CSClassA methodsFor: 'partial methods' stamp: 'mpe 11/7/2010 18:28'!
myMethod
	<before: #beforeLayer>
	self executed: #beforeLayer! !

!CSClassA methodsFor: 'partial methods' stamp: 'mpe 2/16/2011 12:09'!
myReturnMethod
	<around: #aroundLayer>
	^ #around! !

!CSClassA methodsFor: 'non local return' stamp: 'mpe 11/7/2010 18:07'!
nonLocalReturn
	|  aBlock |
	aBlock :=  [^ false].
	#l1 withLayerDo: [self valueBlock: aBlock].! !

!CSClassA methodsFor: 'non local return' stamp: 'mpe 11/7/2010 18:07'!
valueBlock: aBlock

	aBlock value.! !

Object subclass: #CSClassB
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSClassB methodsFor: 'accessing' stamp: 'mpe 8/10/2010 21:28'!
count

	^ count! !

!CSClassB methodsFor: 'initialize-release' stamp: 'mpe 8/10/2010 22:32'!
initialize

	count := 1.! !

CSClassB subclass: #CSSubclassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

Object subclass: #CSLayeredMethod
	instanceVariableNames: 'methods cache methodClass selector executedPartialMethod selectedPartialMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSLayeredMethod class methodsFor: 'instance creation' stamp: 'mpe 8/6/2010 16:34'!
on: methods

	^ self new
		methods: methods asOrderedCollection! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 17:07'!
addBaseMethod: aCompiledMethod
	self includesBaseMethod
		ifTrue: [self methods removeLast].
	self methods addLast: aCompiledMethod asPartialMethod.! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 17:26'!
addPartialMethod: aPartialMethod
	| oldPartialMethod |
	(self includesPartialMethod: aPartialMethod)
		ifTrue: [
			oldPartialMethod := self getPartialMethod: aPartialMethod.
			self methods 
				add: aPartialMethod before: oldPartialMethod;
				remove: oldPartialMethod ifAbsent: [self error: 'Should not happen']]
		ifFalse: [self includesBaseMethod
					ifTrue: [self methods add: aPartialMethod before: self baseMethod]
					ifFalse: [self methods addLast: aPartialMethod]]
	! !

!CSLayeredMethod methodsFor: 'caching partial methods' stamp: 'mpe 11/7/2010 19:47'!
addPartialMethods: aCollectionOfPartialMethods for: activeLayers into: methodChain
	activeLayers reverseDo: [:each | 
		aCollectionOfPartialMethods select: [:method | method layer includes: each]
			thenDo: [:method | methodChain add: method]].! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 11/7/2010 19:32'!
afterMethods

	^ self methods select: [:each | each when == #after:]
! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 11/7/2010 19:33'!
aroundMethods

	^ self methods select: [:each | each when == #around:]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 16:26'!
baseMethod

	self methods last when == #base
		ifTrue: [^ self methods last]
		ifFalse: [^ nil]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 2/16/2011 14:18'!
baseMethodWith: aReceiver arguments: anArray
	| overloadedMethods calledTypes declaredTypes match |
	overloadedMethods := self methods select: [:each | each when == #types:].
	overloadedMethods ifNotEmpty: [
		calledTypes := anArray collect: [:each | each class].
		overloadedMethods do: [:each |
			declaredTypes := each layer collect: [:symbol | Smalltalk at: symbol].
			match := true.
			declaredTypes withIndexDo: [:type :index | 
				((calledTypes at: index) includesBehavior: type)
					ifFalse: [match := false]].
			match
				ifTrue: [^ each]]].
	self methods last when == #base
		ifTrue: [^ self methods last]
		ifFalse: [^ nil]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 11/7/2010 19:32'!
beforeMethods

	^ self methods select: [:each | each when == #before:]! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 16:36'!
cache
	"Answer the value of cache"

	^ cache! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 16:36'!
cache: anObject
	"Set the value of cache"

	cache := anObject! !

!CSLayeredMethod methodsFor: 'caching partial methods' stamp: 'mpe 2/16/2011 13:52'!
cacheMethods: activeLayers
	| methodChain baseMethod |
	self flag: #mpe. "Redundant code to chacheMethods:with:argument:"
	self flag: #mpe. "ToDo: Cache already computed chains"
	methodChain :=  OrderedCollection new.
	self addPartialMethods: self beforeMethods for: activeLayers into: methodChain.
	self addPartialMethods: self aroundMethods for: activeLayers into: methodChain.
	baseMethod := self baseMethod.
	baseMethod ifNotNil: [methodChain add: baseMethod].
	self addPartialMethods: self afterMethods for: activeLayers into: methodChain.	
	^ methodChain! !

!CSLayeredMethod methodsFor: 'caching partial methods' stamp: 'mpe 2/16/2011 13:54'!
cacheMethods: activeLayers with: aReceiver arguments: anArray
	| methodChain baseMethod |
	self flag: #mpe. "ToDo: Cache already computed chains"
	methodChain :=  OrderedCollection new.
	self addPartialMethods: self beforeMethods for: activeLayers into: methodChain.
	self addPartialMethods: self aroundMethods for: activeLayers into: methodChain.
	baseMethod := self baseMethodWith: aReceiver arguments: anArray.
	baseMethod ifNotNil: [methodChain add: baseMethod].
	self addPartialMethods: self afterMethods for: activeLayers into: methodChain.	
	^ methodChain! !

!CSLayeredMethod methodsFor: 'caching partial methods' stamp: 'mp 6/13/2010 14:13'!
clearCache
	cache := Dictionary new.! !

!CSLayeredMethod methodsFor: 'error handling' stamp: 'mpe 8/6/2010 21:31'!
doesNotUnderstand: aMessage
	"required for all meta messages that need information from the original method"
	^ self methods last perform: aMessage selector withArguments: aMessage arguments! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 11/7/2010 20:33'!
executedPartialMethod
	"Answer the value of executedPartialMethod"

	^ executedPartialMethod! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 11/7/2010 20:33'!
executedPartialMethod: anObject
	"Set the value of executedPartialMethod"

	executedPartialMethod := anObject! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 17:22'!
getPartialMethod: aPartialMethod
	^ self methods 
		detect: [:each | (each when = aPartialMethod when) and: [each layer = aPartialMethod layer]] 
		ifNone: [nil]! !

!CSLayeredMethod methodsFor: 'browser' stamp: 'mpe 8/6/2010 21:27'!
getSourceFor: selector in: class
	"Overwritten for ContextBrowser"
	self selectedPartialMethod 
		ifNil: [^ self methods last perform: #getSourceFor:in: withArguments: {selector. class}]
		ifNotNil: [^ self selectedPartialMethod perform: #getSourceFor:in: withArguments: {selector. class}]! !

!CSLayeredMethod methodsFor: 'testing' stamp: 'mpe 8/6/2010 16:27'!
includesBaseMethod

	^ self baseMethod notNil! !

!CSLayeredMethod methodsFor: 'testing' stamp: 'mpe 8/6/2010 17:20'!
includesPartialMethod: aPartialMethod

	^ (self getPartialMethod: aPartialMethod) notNil! !

!CSLayeredMethod methodsFor: 'initialize-release' stamp: 'mp 6/13/2010 14:10'!
initialize
	self clearCache.! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mp 6/14/2010 22:39'!
localActivatedLayers
	^ Processor activeProcess activeLayers! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 16:36'!
methodClass
	"Answer the value of methodClass"

	^ methodClass! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 16:36'!
methodClass: anObject
	"Set the value of methodClass"

	methodClass := anObject! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:08'!
methods
	"Answer the value of methods"

	^ methods! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:13'!
methods: anObject
	"Set the value of methods"

	methods := anObject.
	self clearCache.! !

!CSLayeredMethod methodsFor: 'proceed' stamp: 'mpe 2/16/2011 13:50'!
nextPartialMethod
	| methodChain found |
	self flag: #mpe. "Is it right to recompute methodChain with 'new' local activated layers so the chain can be corrupt and different to the first version at startUp of the layered method? "
	self flag: #mpe. "Attention: types: can replace base methods and so the following is not correct anymore for overloaded methods"
	found := false.
	methodChain := self cacheMethods: self localActivatedLayers.
	methodChain do: [:each | 
		found 
			ifTrue: [found := false.
				(#(around: base) includes: each when)
					ifTrue: [
						self executedPartialMethod: each.
						^ self executedPartialMethod]].
		each == executedPartialMethod
			ifTrue: [found := true]].
	^ nil! !

!CSLayeredMethod methodsFor: 'proceed' stamp: 'mpe 11/7/2010 20:21'!
registerProceed: aReceiver
	self flag: #mpe. "Check whether this key is already in use if this is the case check whether is a CSProceedMethod and register itself in it otherwise throw an exception that proceed must not be implemented if ContextS should be used"
	aReceiver class methodDict at: #proceed: put: (CSProceedMethod on: self).! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 21:52'!
removePartialMethod: aPartialMethod
	self selectedPartialMethod == aPartialMethod
		ifTrue: [self selectedPartialMethod: nil].
	self methods remove: aPartialMethod.
! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'mp 6/14/2010 22:02'!
run: aSelector with: anArrayOfObjects in: aReceiver
	^ self valueWithReceiver: aReceiver arguments: anArrayOfObjects! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 21:15'!
selectedPartialMethod
	"Answer the value of selectedPartialMethod"

	^ selectedPartialMethod! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 21:15'!
selectedPartialMethod: anObject
	"Set the value of selectedPartialMethod"

	selectedPartialMethod := anObject! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 16:37'!
selector
	"Answer the value of selector"

	^ selector! !

!CSLayeredMethod methodsFor: 'accessing' stamp: 'mpe 8/6/2010 16:37'!
selector: anObject
	"Set the value of selector"

	selector := anObject! !

!CSLayeredMethod methodsFor: 'proceed' stamp: 'mpe 11/7/2010 20:22'!
unregisterProceed: aReceiver
	(aReceiver class methodDict includesKey: #proceed:)
		ifTrue: [aReceiver class methodDict removeKey: #proceed:].
	self flag: #mpe. "check that at #proceed: is the right CSProceedMethod and that no one else requires this method"! !

!CSLayeredMethod methodsFor: 'executing' stamp: 'mpe 2/16/2011 13:47'!
valueWithReceiver: aReceiver arguments: anArray
	| methodChain aroundCalled result |
	self registerProceed: aReceiver.
	aroundCalled := false.
	methodChain := self cacheMethods: self localActivatedLayers with: aReceiver arguments: anArray.
	[methodChain do: [:each | 
		self executedPartialMethod: each.
		each when caseOf: {
			[#before:] -> [each valueWithReceiver: aReceiver arguments: anArray].
			[#around:] -> [aroundCalled 
							ifFalse: [aroundCalled := true.
								      result := each valueWithReceiver: aReceiver arguments: anArray]].
			[#base] -> [aroundCalled 
							ifFalse: [aroundCalled := true.
								      result := each valueWithReceiver: aReceiver arguments: anArray]].
			[#types:] -> [aroundCalled 
							ifFalse: [aroundCalled := true.
								      result := each valueWithReceiver: aReceiver arguments: anArray]].								
			[#after:] -> [each valueWithReceiver: aReceiver arguments: anArray].		
		}]] 
		ensure: [self unregisterProceed: aReceiver].
	^ result! !

Object subclass: #CSMethodOverloading
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSMethodOverloading methodsFor: 'as yet unclassified' stamp: 'mpe 2/16/2011 13:30'!
+ aFloat
	<types: #Float>
	^#Float! !

Object subclass: #CSMyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSMyClass methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 20:59'!
bla
	<around: #l4>! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:54'!
blub
	<after: #(l1, l2, l5)>
	self blub.
	3 +4 +7! !

!CSMyClass methodsFor: 'as yet unclassified' stamp: 'mpe 8/10/2010 22:58'!
no
	self blub.! !

CSMyClass subclass: #CSMyClassSub
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2-Tests-Sandbox'!

!CSMyClassSub methodsFor: 'as yet unclassified' stamp: 'mpe 8/10/2010 22:58'!
blub

	"neu in sub"! !

!CSMyClassSub methodsFor: 'as yet unclassified' stamp: 'mpe 8/10/2010 22:58'!
no
! !

!CSMyClassSub methodsFor: 'as yet unclassified' stamp: 'mpe 8/10/2010 22:57'!
partialOnly
	<around: #l4>
	self huhu.
	super partialOnly.! !

Object subclass: #CSPartialMethod
	instanceVariableNames: 'IAmAFixDontDeleteMe method when layer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSPartialMethod class methodsFor: 'instance creation' stamp: 'mp 6/14/2010 22:28'!
layer: aLayer method: aMethod when: aSymbol

	^ self new
		method: aMethod;
		layer: aLayer;
		when: aSymbol;
		yourself! !

!CSPartialMethod methodsFor: 'as yet unclassified' stamp: 'mpe 8/6/2010 21:13'!
asMenuString

	self layer ifNil: [^ self when asString].
	^ self when asString, ' ', (self layer inject: '' into: [:str :each | str := str, each asString, Character space])! !

!CSPartialMethod methodsFor: 'error handling' stamp: 'mp 6/13/2010 17:58'!
doesNotUnderstand: aMessage
	"required for all meta messages that need information from the original method"
	^ self method perform: aMessage selector withArguments: aMessage arguments! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
layer
	"Answer the value of layer"

	^ layer! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
layer: anObject
	"Set the value of layer"

	layer := anObject! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
method
	"Answer the value of method"

	^ method! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
method: anObject
	"Set the value of method"

	method := anObject! !

!CSPartialMethod methodsFor: 'as yet unclassified' stamp: 'mp 6/13/2010 17:58'!
run: aSelector with: anArrayOfObjects in: aReceiver
	^ self valueWithReceiver: aReceiver arguments: anArrayOfObjects! !

!CSPartialMethod methodsFor: 'as yet unclassified' stamp: 'mp 6/14/2010 22:03'!
valueWithReceiver: aReceiver arguments: anArray
	^ aReceiver withArgs: anArray executeMethod: self method! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
when
	"Answer the value of when"

	^ when! !

!CSPartialMethod methodsFor: 'accessing' stamp: 'mp 6/13/2010 14:19'!
when: anObject
	"Set the value of when"

	when := anObject! !

Object subclass: #CSProceedMethod
	instanceVariableNames: 'layeredMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ContextS2'!

!CSProceedMethod class methodsFor: 'as yet unclassified' stamp: 'mpe 7/5/2010 21:50'!
on: aLayeredMethod

	^ self new
		layeredMethod: aLayeredMethod;
		yourself! !

!CSProceedMethod methodsFor: 'as yet unclassified' stamp: 'mpe 7/5/2010 21:20'!
doesNotUnderstand: aMessage
	"ignore method meta messages"! !

!CSProceedMethod methodsFor: 'accessing' stamp: 'mpe 7/5/2010 21:51'!
layeredMethod
	"Answer the value of layeredMethod"

	^ layeredMethod! !

!CSProceedMethod methodsFor: 'accessing' stamp: 'mpe 7/5/2010 21:51'!
layeredMethod: anObject
	"Set the value of layeredMethod"

	layeredMethod := anObject! !

!CSProceedMethod methodsFor: 'as yet unclassified' stamp: 'mpe 11/7/2010 20:42'!
run: aSelector with: anArrayOfObjects in: aReceiver
	self flag: #mpe. "Attention: anArrayOfObjects FIRST is not correct!!"
	self flag: #mpe. "nextPartialMethod can be nil then the call should be forwarded to super?"
	^ aReceiver withArgs: anArrayOfObjects first executeMethod: self layeredMethod nextPartialMethod! !

!ByteSymbol methodsFor: '*ContextS2' stamp: 'mpe 8/3/2010 23:08'!
withLayerDo: aBlock
	(Array with: self) withLayersDo: aBlock.! !

!ByteSymbol methodsFor: '*ContextS2' stamp: 'mpe 8/3/2010 23:09'!
withoutLayerDo: aBlock
	(Array with: self) withoutLayersDo: aBlock.! !

!Array methodsFor: '*ContextS2' stamp: 'mpe 8/3/2010 22:39'!
activeProcess
	^ Processor activeProcess! !

!Array methodsFor: '*ContextS2' stamp: 'mpe 8/3/2010 23:03'!
withLayersDo: aBlock
	| oldLayers |
	oldLayers := self activeProcess activeLayers copy.
	 "Push activated layer at top of layer stack"
	self activeProcess activeLayers: ((oldLayers copyWithoutAll: self), self).
	[aBlock value] ensure: [self activeProcess activeLayers: oldLayers].! !

!Array methodsFor: '*ContextS2' stamp: 'mpe 8/3/2010 23:04'!
withoutLayersDo: aBlock
	| oldLayers |
	oldLayers := self activeProcess activeLayers copy.
	 "Push activated layer at top of layer stack"
	self activeProcess activeLayers: (oldLayers copyWithoutAll: self).
	[aBlock value] ensure: [self activeProcess activeLayers: oldLayers].! !
